import java.applet.Applet;
import java.awt.BorderLayout;

import javax.media.opengl.GLCanvas;
import javax.swing.JPanel;

import com.sun.opengl.util.FPSAnimator;

/**
 * Applet version of the jellyfish robot rendering, for dynamic web pages.
 * @author Damian Johnson
 * @version November 10 2007
 */
public class AppletStarter extends Applet {
  public static final long serialVersionUID = 0;
  private FPSAnimator animator;
  
  public void init() {
    setLayout(new BorderLayout());
    // GLCapabilities caps = new GLCapabilities();
    // caps.setDoubleBuffered(true); // Enables double buffering
    // caps.setHardwareAccelerated(true);
    
    GLCanvas canvas = new GLCanvas();
    ViewTracker tracker = new ViewTracker();
    // GLJPanel panel = new GLJPanel(caps); // Swing variant lacks hardware acceleration
    ToroidalRenderer renderer = new ToroidalRenderer(ToroidalRenderer.DrawType.SOLID, tracker);
    canvas.addGLEventListener(renderer);
    canvas.addMouseListener(tracker);
    canvas.addMouseMotionListener(tracker);
    canvas.setSize(getSize());
    
    add(canvas, BorderLayout.CENTER);
    this.animator = new FPSAnimator(canvas, 20);
    this.animator.setRunAsFastAsPossible(false); // Restricts rate that display is called
    
    // Adds side controls
    JPanel wrapper = new JPanel(new BorderLayout());
    wrapper.add(Starter.makeControls(renderer), BorderLayout.NORTH);
    add(wrapper, BorderLayout.EAST);
  }
  
  public void start() {
    this.animator.start();
  }
  
  public void stop() {
    this.animator.stop();
  }
}
